# coding: utf-8

"""
    College Basketball Data API

    This API is in limited Beta for Patreon subscribers. It may have bugs and is subject to changes. API keys can be acquired from the CollegeFootballData.com website.

    The version of the OpenAPI document: 1.18.0
    Contact: admin@collegefootballdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr, conlist
from cbbd.models.lineup_unit_stats import LineupUnitStats
from cbbd.models.play_info_participants_inner import PlayInfoParticipantsInner

class LineupStats(BaseModel):
    """
    LineupStats
    """
    team_id: StrictInt = Field(default=..., alias="teamId")
    team: StrictStr = Field(...)
    conference: StrictStr = Field(...)
    id_hash: StrictStr = Field(default=..., alias="idHash")
    athletes: conlist(PlayInfoParticipantsInner) = Field(...)
    total_seconds: Union[StrictFloat, StrictInt] = Field(default=..., alias="totalSeconds")
    pace: Union[StrictFloat, StrictInt] = Field(...)
    offense_rating: Union[StrictFloat, StrictInt] = Field(default=..., alias="offenseRating")
    defense_rating: Union[StrictFloat, StrictInt] = Field(default=..., alias="defenseRating")
    net_rating: Union[StrictFloat, StrictInt] = Field(default=..., alias="netRating")
    team_stats: LineupUnitStats = Field(default=..., alias="teamStats")
    opponent_stats: LineupUnitStats = Field(default=..., alias="opponentStats")
    __properties = ["teamId", "team", "conference", "idHash", "athletes", "totalSeconds", "pace", "offenseRating", "defenseRating", "netRating", "teamStats", "opponentStats"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> LineupStats:
        """Create an instance of LineupStats from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in athletes (list)
        _items = []
        if self.athletes:
            for _item in self.athletes:
                if _item:
                    _items.append(_item.to_dict())
            _dict['athletes'] = _items
        # override the default output from pydantic by calling `to_dict()` of team_stats
        if self.team_stats:
            _dict['teamStats'] = self.team_stats.to_dict()
        # override the default output from pydantic by calling `to_dict()` of opponent_stats
        if self.opponent_stats:
            _dict['opponentStats'] = self.opponent_stats.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> LineupStats:
        """Create an instance of LineupStats from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return LineupStats.parse_obj(obj)

        _obj = LineupStats.parse_obj({
            "team_id": obj.get("teamId"),
            "team": obj.get("team"),
            "conference": obj.get("conference"),
            "id_hash": obj.get("idHash"),
            "athletes": [PlayInfoParticipantsInner.from_dict(_item) for _item in obj.get("athletes")] if obj.get("athletes") is not None else None,
            "total_seconds": obj.get("totalSeconds"),
            "pace": obj.get("pace"),
            "offense_rating": obj.get("offenseRating"),
            "defense_rating": obj.get("defenseRating"),
            "net_rating": obj.get("netRating"),
            "team_stats": LineupUnitStats.from_dict(obj.get("teamStats")) if obj.get("teamStats") is not None else None,
            "opponent_stats": LineupUnitStats.from_dict(obj.get("opponentStats")) if obj.get("opponentStats") is not None else None
        })
        return _obj


